<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/ryu-1.0.10/src/d2s.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>d2s.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../ryu/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../ryu/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../ryu/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
<span id="284">284</span>
<span id="285">285</span>
<span id="286">286</span>
<span id="287">287</span>
<span id="288">288</span>
<span id="289">289</span>
<span id="290">290</span>
<span id="291">291</span>
<span id="292">292</span>
<span id="293">293</span>
<span id="294">294</span>
<span id="295">295</span>
<span id="296">296</span>
<span id="297">297</span>
<span id="298">298</span>
<span id="299">299</span>
<span id="300">300</span>
</pre><pre class="rust"><code><span class="comment">// Translated from C to Rust. The original C code can be found at</span>
<span class="comment">// https://github.com/ulfjack/ryu and carries the following license:</span>
<span class="comment">//</span>
<span class="comment">// Copyright 2018 Ulf Adams</span>
<span class="comment">//</span>
<span class="comment">// The contents of this file may be used under the terms of the Apache License,</span>
<span class="comment">// Version 2.0.</span>
<span class="comment">//</span>
<span class="comment">//    (See accompanying file LICENSE-Apache or copy at</span>
<span class="comment">//     http://www.apache.org/licenses/LICENSE-2.0)</span>
<span class="comment">//</span>
<span class="comment">// Alternatively, the contents of this file may be used under the terms of</span>
<span class="comment">// the Boost Software License, Version 1.0.</span>
<span class="comment">//    (See accompanying file LICENSE-Boost or copy at</span>
<span class="comment">//     https://www.boost.org/LICENSE_1_0.txt)</span>
<span class="comment">//</span>
<span class="comment">// Unless required by applicable law or agreed to in writing, this software</span>
<span class="comment">// is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY</span>
<span class="comment">// KIND, either express or implied.</span>

<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::common</span>::<span class="kw-2">*</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;small&quot;</span>))]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::d2s_full_table</span>::<span class="kw-2">*</span>;
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::d2s_intrinsics</span>::<span class="kw-2">*</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;small&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::d2s_small_table</span>::<span class="kw-2">*</span>;
<span class="kw">use</span> <span class="ident">core::mem::MaybeUninit</span>;

<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">DOUBLE_MANTISSA_BITS</span>: <span class="ident">u32</span> <span class="op">=</span> <span class="number">52</span>;
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">DOUBLE_EXPONENT_BITS</span>: <span class="ident">u32</span> <span class="op">=</span> <span class="number">11</span>;
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">DOUBLE_BIAS</span>: <span class="ident">i32</span> <span class="op">=</span> <span class="number">1023</span>;
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">DOUBLE_POW5_INV_BITCOUNT</span>: <span class="ident">i32</span> <span class="op">=</span> <span class="number">125</span>;
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">DOUBLE_POW5_BITCOUNT</span>: <span class="ident">i32</span> <span class="op">=</span> <span class="number">125</span>;

<span class="attribute">#[<span class="ident">cfg_attr</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;no-panic&quot;</span>, <span class="ident">inline</span>)]</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">decimal_length17</span>(<span class="ident">v</span>: <span class="ident">u64</span>) -&gt; <span class="ident">u32</span> {
    <span class="comment">// This is slightly faster than a loop.</span>
    <span class="comment">// The average output length is 16.38 digits, so we check high-to-low.</span>
    <span class="comment">// Function precondition: v is not an 18, 19, or 20-digit number.</span>
    <span class="comment">// (17 digits are sufficient for round-tripping.)</span>
    <span class="macro">debug_assert!</span>(<span class="ident">v</span> <span class="op">&lt;</span> <span class="number">100000000000000000</span>);

    <span class="kw">if</span> <span class="ident">v</span> <span class="op">&gt;</span><span class="op">=</span> <span class="number">10000000000000000</span> {
        <span class="number">17</span>
    } <span class="kw">else</span> <span class="kw">if</span> <span class="ident">v</span> <span class="op">&gt;</span><span class="op">=</span> <span class="number">1000000000000000</span> {
        <span class="number">16</span>
    } <span class="kw">else</span> <span class="kw">if</span> <span class="ident">v</span> <span class="op">&gt;</span><span class="op">=</span> <span class="number">100000000000000</span> {
        <span class="number">15</span>
    } <span class="kw">else</span> <span class="kw">if</span> <span class="ident">v</span> <span class="op">&gt;</span><span class="op">=</span> <span class="number">10000000000000</span> {
        <span class="number">14</span>
    } <span class="kw">else</span> <span class="kw">if</span> <span class="ident">v</span> <span class="op">&gt;</span><span class="op">=</span> <span class="number">1000000000000</span> {
        <span class="number">13</span>
    } <span class="kw">else</span> <span class="kw">if</span> <span class="ident">v</span> <span class="op">&gt;</span><span class="op">=</span> <span class="number">100000000000</span> {
        <span class="number">12</span>
    } <span class="kw">else</span> <span class="kw">if</span> <span class="ident">v</span> <span class="op">&gt;</span><span class="op">=</span> <span class="number">10000000000</span> {
        <span class="number">11</span>
    } <span class="kw">else</span> <span class="kw">if</span> <span class="ident">v</span> <span class="op">&gt;</span><span class="op">=</span> <span class="number">1000000000</span> {
        <span class="number">10</span>
    } <span class="kw">else</span> <span class="kw">if</span> <span class="ident">v</span> <span class="op">&gt;</span><span class="op">=</span> <span class="number">100000000</span> {
        <span class="number">9</span>
    } <span class="kw">else</span> <span class="kw">if</span> <span class="ident">v</span> <span class="op">&gt;</span><span class="op">=</span> <span class="number">10000000</span> {
        <span class="number">8</span>
    } <span class="kw">else</span> <span class="kw">if</span> <span class="ident">v</span> <span class="op">&gt;</span><span class="op">=</span> <span class="number">1000000</span> {
        <span class="number">7</span>
    } <span class="kw">else</span> <span class="kw">if</span> <span class="ident">v</span> <span class="op">&gt;</span><span class="op">=</span> <span class="number">100000</span> {
        <span class="number">6</span>
    } <span class="kw">else</span> <span class="kw">if</span> <span class="ident">v</span> <span class="op">&gt;</span><span class="op">=</span> <span class="number">10000</span> {
        <span class="number">5</span>
    } <span class="kw">else</span> <span class="kw">if</span> <span class="ident">v</span> <span class="op">&gt;</span><span class="op">=</span> <span class="number">1000</span> {
        <span class="number">4</span>
    } <span class="kw">else</span> <span class="kw">if</span> <span class="ident">v</span> <span class="op">&gt;</span><span class="op">=</span> <span class="number">100</span> {
        <span class="number">3</span>
    } <span class="kw">else</span> <span class="kw">if</span> <span class="ident">v</span> <span class="op">&gt;</span><span class="op">=</span> <span class="number">10</span> {
        <span class="number">2</span>
    } <span class="kw">else</span> {
        <span class="number">1</span>
    }
}

<span class="comment">// A floating decimal representing m * 10^e.</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">FloatingDecimal64</span> {
    <span class="kw">pub</span> <span class="ident">mantissa</span>: <span class="ident">u64</span>,
    <span class="comment">// Decimal exponent&#39;s range is -324 to 308</span>
    <span class="comment">// inclusive, and can fit in i16 if needed.</span>
    <span class="kw">pub</span> <span class="ident">exponent</span>: <span class="ident">i32</span>,
}

<span class="attribute">#[<span class="ident">cfg_attr</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;no-panic&quot;</span>, <span class="ident">inline</span>)]</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">d2d</span>(<span class="ident">ieee_mantissa</span>: <span class="ident">u64</span>, <span class="ident">ieee_exponent</span>: <span class="ident">u32</span>) -&gt; <span class="ident">FloatingDecimal64</span> {
    <span class="kw">let</span> (<span class="ident">e2</span>, <span class="ident">m2</span>) <span class="op">=</span> <span class="kw">if</span> <span class="ident">ieee_exponent</span> <span class="op">==</span> <span class="number">0</span> {
        (
            <span class="comment">// We subtract 2 so that the bounds computation has 2 additional bits.</span>
            <span class="number">1</span> <span class="op">-</span> <span class="ident">DOUBLE_BIAS</span> <span class="op">-</span> <span class="ident">DOUBLE_MANTISSA_BITS</span> <span class="kw">as</span> <span class="ident">i32</span> <span class="op">-</span> <span class="number">2</span>,
            <span class="ident">ieee_mantissa</span>,
        )
    } <span class="kw">else</span> {
        (
            <span class="ident">ieee_exponent</span> <span class="kw">as</span> <span class="ident">i32</span> <span class="op">-</span> <span class="ident">DOUBLE_BIAS</span> <span class="op">-</span> <span class="ident">DOUBLE_MANTISSA_BITS</span> <span class="kw">as</span> <span class="ident">i32</span> <span class="op">-</span> <span class="number">2</span>,
            (<span class="number">1u64</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="ident">DOUBLE_MANTISSA_BITS</span>) <span class="op">|</span> <span class="ident">ieee_mantissa</span>,
        )
    };
    <span class="kw">let</span> <span class="ident">even</span> <span class="op">=</span> (<span class="ident">m2</span> <span class="op">&amp;</span> <span class="number">1</span>) <span class="op">==</span> <span class="number">0</span>;
    <span class="kw">let</span> <span class="ident">accept_bounds</span> <span class="op">=</span> <span class="ident">even</span>;

    <span class="comment">// Step 2: Determine the interval of valid decimal representations.</span>
    <span class="kw">let</span> <span class="ident">mv</span> <span class="op">=</span> <span class="number">4</span> <span class="op">*</span> <span class="ident">m2</span>;
    <span class="comment">// Implicit bool -&gt; int conversion. True is 1, false is 0.</span>
    <span class="kw">let</span> <span class="ident">mm_shift</span> <span class="op">=</span> (<span class="ident">ieee_mantissa</span> <span class="op">!</span><span class="op">=</span> <span class="number">0</span> <span class="op">|</span><span class="op">|</span> <span class="ident">ieee_exponent</span> <span class="op">&lt;</span><span class="op">=</span> <span class="number">1</span>) <span class="kw">as</span> <span class="ident">u32</span>;
    <span class="comment">// We would compute mp and mm like this:</span>
    <span class="comment">// uint64_t mp = 4 * m2 + 2;</span>
    <span class="comment">// uint64_t mm = mv - 1 - mm_shift;</span>

    <span class="comment">// Step 3: Convert to a decimal power base using 128-bit arithmetic.</span>
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">vr</span>: <span class="ident">u64</span>;
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">vp</span>: <span class="ident">u64</span>;
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">vm</span>: <span class="ident">u64</span>;
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">vp_uninit</span>: <span class="ident">MaybeUninit</span><span class="op">&lt;</span><span class="ident">u64</span><span class="op">&gt;</span> <span class="op">=</span> <span class="ident">MaybeUninit::uninit</span>();
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">vm_uninit</span>: <span class="ident">MaybeUninit</span><span class="op">&lt;</span><span class="ident">u64</span><span class="op">&gt;</span> <span class="op">=</span> <span class="ident">MaybeUninit::uninit</span>();
    <span class="kw">let</span> <span class="ident">e10</span>: <span class="ident">i32</span>;
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">vm_is_trailing_zeros</span> <span class="op">=</span> <span class="bool-val">false</span>;
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">vr_is_trailing_zeros</span> <span class="op">=</span> <span class="bool-val">false</span>;
    <span class="kw">if</span> <span class="ident">e2</span> <span class="op">&gt;</span><span class="op">=</span> <span class="number">0</span> {
        <span class="comment">// I tried special-casing q == 0, but there was no effect on performance.</span>
        <span class="comment">// This expression is slightly faster than max(0, log10_pow2(e2) - 1).</span>
        <span class="kw">let</span> <span class="ident">q</span> <span class="op">=</span> <span class="ident">log10_pow2</span>(<span class="ident">e2</span>) <span class="op">-</span> (<span class="ident">e2</span> <span class="op">&gt;</span> <span class="number">3</span>) <span class="kw">as</span> <span class="ident">u32</span>;
        <span class="ident">e10</span> <span class="op">=</span> <span class="ident">q</span> <span class="kw">as</span> <span class="ident">i32</span>;
        <span class="kw">let</span> <span class="ident">k</span> <span class="op">=</span> <span class="ident">DOUBLE_POW5_INV_BITCOUNT</span> <span class="op">+</span> <span class="ident">pow5bits</span>(<span class="ident">q</span> <span class="kw">as</span> <span class="ident">i32</span>) <span class="op">-</span> <span class="number">1</span>;
        <span class="kw">let</span> <span class="ident">i</span> <span class="op">=</span> <span class="op">-</span><span class="ident">e2</span> <span class="op">+</span> <span class="ident">q</span> <span class="kw">as</span> <span class="ident">i32</span> <span class="op">+</span> <span class="ident">k</span>;
        <span class="ident">vr</span> <span class="op">=</span> <span class="kw">unsafe</span> {
            <span class="ident">mul_shift_all_64</span>(
                <span class="ident">m2</span>,
                <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;small&quot;</span>)]</span>
                <span class="kw-2">&amp;</span><span class="ident">compute_inv_pow5</span>(<span class="ident">q</span>),
                <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;small&quot;</span>))]</span>
                {
                    <span class="macro">debug_assert!</span>(<span class="ident">q</span> <span class="op">&lt;</span> <span class="ident">DOUBLE_POW5_INV_SPLIT</span>.<span class="ident">len</span>() <span class="kw">as</span> <span class="ident">u32</span>);
                    <span class="ident">DOUBLE_POW5_INV_SPLIT</span>.<span class="ident">get_unchecked</span>(<span class="ident">q</span> <span class="kw">as</span> <span class="ident">usize</span>)
                },
                <span class="ident">i</span> <span class="kw">as</span> <span class="ident">u32</span>,
                <span class="ident">vp_uninit</span>.<span class="ident">as_mut_ptr</span>(),
                <span class="ident">vm_uninit</span>.<span class="ident">as_mut_ptr</span>(),
                <span class="ident">mm_shift</span>,
            )
        };
        <span class="ident">vp</span> <span class="op">=</span> <span class="kw">unsafe</span> { <span class="ident">vp_uninit</span>.<span class="ident">assume_init</span>() };
        <span class="ident">vm</span> <span class="op">=</span> <span class="kw">unsafe</span> { <span class="ident">vm_uninit</span>.<span class="ident">assume_init</span>() };
        <span class="kw">if</span> <span class="ident">q</span> <span class="op">&lt;</span><span class="op">=</span> <span class="number">21</span> {
            <span class="comment">// This should use q &lt;= 22, but I think 21 is also safe. Smaller values</span>
            <span class="comment">// may still be safe, but it&#39;s more difficult to reason about them.</span>
            <span class="comment">// Only one of mp, mv, and mm can be a multiple of 5, if any.</span>
            <span class="kw">let</span> <span class="ident">mv_mod5</span> <span class="op">=</span> (<span class="ident">mv</span> <span class="kw">as</span> <span class="ident">u32</span>).<span class="ident">wrapping_sub</span>(<span class="number">5u32</span>.<span class="ident">wrapping_mul</span>(<span class="ident">div5</span>(<span class="ident">mv</span>) <span class="kw">as</span> <span class="ident">u32</span>));
            <span class="kw">if</span> <span class="ident">mv_mod5</span> <span class="op">==</span> <span class="number">0</span> {
                <span class="ident">vr_is_trailing_zeros</span> <span class="op">=</span> <span class="ident">multiple_of_power_of_5</span>(<span class="ident">mv</span>, <span class="ident">q</span>);
            } <span class="kw">else</span> <span class="kw">if</span> <span class="ident">accept_bounds</span> {
                <span class="comment">// Same as min(e2 + (~mm &amp; 1), pow5_factor(mm)) &gt;= q</span>
                <span class="comment">// &lt;=&gt; e2 + (~mm &amp; 1) &gt;= q &amp;&amp; pow5_factor(mm) &gt;= q</span>
                <span class="comment">// &lt;=&gt; true &amp;&amp; pow5_factor(mm) &gt;= q, since e2 &gt;= q.</span>
                <span class="ident">vm_is_trailing_zeros</span> <span class="op">=</span> <span class="ident">multiple_of_power_of_5</span>(<span class="ident">mv</span> <span class="op">-</span> <span class="number">1</span> <span class="op">-</span> <span class="ident">mm_shift</span> <span class="kw">as</span> <span class="ident">u64</span>, <span class="ident">q</span>);
            } <span class="kw">else</span> {
                <span class="comment">// Same as min(e2 + 1, pow5_factor(mp)) &gt;= q.</span>
                <span class="ident">vp</span> <span class="op">-</span><span class="op">=</span> <span class="ident">multiple_of_power_of_5</span>(<span class="ident">mv</span> <span class="op">+</span> <span class="number">2</span>, <span class="ident">q</span>) <span class="kw">as</span> <span class="ident">u64</span>;
            }
        }
    } <span class="kw">else</span> {
        <span class="comment">// This expression is slightly faster than max(0, log10_pow5(-e2) - 1).</span>
        <span class="kw">let</span> <span class="ident">q</span> <span class="op">=</span> <span class="ident">log10_pow5</span>(<span class="op">-</span><span class="ident">e2</span>) <span class="op">-</span> (<span class="op">-</span><span class="ident">e2</span> <span class="op">&gt;</span> <span class="number">1</span>) <span class="kw">as</span> <span class="ident">u32</span>;
        <span class="ident">e10</span> <span class="op">=</span> <span class="ident">q</span> <span class="kw">as</span> <span class="ident">i32</span> <span class="op">+</span> <span class="ident">e2</span>;
        <span class="kw">let</span> <span class="ident">i</span> <span class="op">=</span> <span class="op">-</span><span class="ident">e2</span> <span class="op">-</span> <span class="ident">q</span> <span class="kw">as</span> <span class="ident">i32</span>;
        <span class="kw">let</span> <span class="ident">k</span> <span class="op">=</span> <span class="ident">pow5bits</span>(<span class="ident">i</span>) <span class="op">-</span> <span class="ident">DOUBLE_POW5_BITCOUNT</span>;
        <span class="kw">let</span> <span class="ident">j</span> <span class="op">=</span> <span class="ident">q</span> <span class="kw">as</span> <span class="ident">i32</span> <span class="op">-</span> <span class="ident">k</span>;
        <span class="ident">vr</span> <span class="op">=</span> <span class="kw">unsafe</span> {
            <span class="ident">mul_shift_all_64</span>(
                <span class="ident">m2</span>,
                <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;small&quot;</span>)]</span>
                <span class="kw-2">&amp;</span><span class="ident">compute_pow5</span>(<span class="ident">i</span> <span class="kw">as</span> <span class="ident">u32</span>),
                <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;small&quot;</span>))]</span>
                {
                    <span class="macro">debug_assert!</span>(<span class="ident">i</span> <span class="op">&lt;</span> <span class="ident">DOUBLE_POW5_SPLIT</span>.<span class="ident">len</span>() <span class="kw">as</span> <span class="ident">i32</span>);
                    <span class="ident">DOUBLE_POW5_SPLIT</span>.<span class="ident">get_unchecked</span>(<span class="ident">i</span> <span class="kw">as</span> <span class="ident">usize</span>)
                },
                <span class="ident">j</span> <span class="kw">as</span> <span class="ident">u32</span>,
                <span class="ident">vp_uninit</span>.<span class="ident">as_mut_ptr</span>(),
                <span class="ident">vm_uninit</span>.<span class="ident">as_mut_ptr</span>(),
                <span class="ident">mm_shift</span>,
            )
        };
        <span class="ident">vp</span> <span class="op">=</span> <span class="kw">unsafe</span> { <span class="ident">vp_uninit</span>.<span class="ident">assume_init</span>() };
        <span class="ident">vm</span> <span class="op">=</span> <span class="kw">unsafe</span> { <span class="ident">vm_uninit</span>.<span class="ident">assume_init</span>() };
        <span class="kw">if</span> <span class="ident">q</span> <span class="op">&lt;</span><span class="op">=</span> <span class="number">1</span> {
            <span class="comment">// {vr,vp,vm} is trailing zeros if {mv,mp,mm} has at least q trailing 0 bits.</span>
            <span class="comment">// mv = 4 * m2, so it always has at least two trailing 0 bits.</span>
            <span class="ident">vr_is_trailing_zeros</span> <span class="op">=</span> <span class="bool-val">true</span>;
            <span class="kw">if</span> <span class="ident">accept_bounds</span> {
                <span class="comment">// mm = mv - 1 - mm_shift, so it has 1 trailing 0 bit iff mm_shift == 1.</span>
                <span class="ident">vm_is_trailing_zeros</span> <span class="op">=</span> <span class="ident">mm_shift</span> <span class="op">==</span> <span class="number">1</span>;
            } <span class="kw">else</span> {
                <span class="comment">// mp = mv + 2, so it always has at least one trailing 0 bit.</span>
                <span class="ident">vp</span> <span class="op">-</span><span class="op">=</span> <span class="number">1</span>;
            }
        } <span class="kw">else</span> <span class="kw">if</span> <span class="ident">q</span> <span class="op">&lt;</span> <span class="number">63</span> {
            <span class="comment">// TODO(ulfjack): Use a tighter bound here.</span>
            <span class="comment">// We want to know if the full product has at least q trailing zeros.</span>
            <span class="comment">// We need to compute min(p2(mv), p5(mv) - e2) &gt;= q</span>
            <span class="comment">// &lt;=&gt; p2(mv) &gt;= q &amp;&amp; p5(mv) - e2 &gt;= q</span>
            <span class="comment">// &lt;=&gt; p2(mv) &gt;= q (because -e2 &gt;= q)</span>
            <span class="ident">vr_is_trailing_zeros</span> <span class="op">=</span> <span class="ident">multiple_of_power_of_2</span>(<span class="ident">mv</span>, <span class="ident">q</span>);
        }
    }

    <span class="comment">// Step 4: Find the shortest decimal representation in the interval of valid representations.</span>
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">removed</span> <span class="op">=</span> <span class="number">0i32</span>;
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">last_removed_digit</span> <span class="op">=</span> <span class="number">0u8</span>;
    <span class="comment">// On average, we remove ~2 digits.</span>
    <span class="kw">let</span> <span class="ident">output</span> <span class="op">=</span> <span class="kw">if</span> <span class="ident">vm_is_trailing_zeros</span> <span class="op">|</span><span class="op">|</span> <span class="ident">vr_is_trailing_zeros</span> {
        <span class="comment">// General case, which happens rarely (~0.7%).</span>
        <span class="kw">loop</span> {
            <span class="kw">let</span> <span class="ident">vp_div10</span> <span class="op">=</span> <span class="ident">div10</span>(<span class="ident">vp</span>);
            <span class="kw">let</span> <span class="ident">vm_div10</span> <span class="op">=</span> <span class="ident">div10</span>(<span class="ident">vm</span>);
            <span class="kw">if</span> <span class="ident">vp_div10</span> <span class="op">&lt;</span><span class="op">=</span> <span class="ident">vm_div10</span> {
                <span class="kw">break</span>;
            }
            <span class="kw">let</span> <span class="ident">vm_mod10</span> <span class="op">=</span> (<span class="ident">vm</span> <span class="kw">as</span> <span class="ident">u32</span>).<span class="ident">wrapping_sub</span>(<span class="number">10u32</span>.<span class="ident">wrapping_mul</span>(<span class="ident">vm_div10</span> <span class="kw">as</span> <span class="ident">u32</span>));
            <span class="kw">let</span> <span class="ident">vr_div10</span> <span class="op">=</span> <span class="ident">div10</span>(<span class="ident">vr</span>);
            <span class="kw">let</span> <span class="ident">vr_mod10</span> <span class="op">=</span> (<span class="ident">vr</span> <span class="kw">as</span> <span class="ident">u32</span>).<span class="ident">wrapping_sub</span>(<span class="number">10u32</span>.<span class="ident">wrapping_mul</span>(<span class="ident">vr_div10</span> <span class="kw">as</span> <span class="ident">u32</span>));
            <span class="ident">vm_is_trailing_zeros</span> <span class="op">&amp;=</span> <span class="ident">vm_mod10</span> <span class="op">==</span> <span class="number">0</span>;
            <span class="ident">vr_is_trailing_zeros</span> <span class="op">&amp;=</span> <span class="ident">last_removed_digit</span> <span class="op">==</span> <span class="number">0</span>;
            <span class="ident">last_removed_digit</span> <span class="op">=</span> <span class="ident">vr_mod10</span> <span class="kw">as</span> <span class="ident">u8</span>;
            <span class="ident">vr</span> <span class="op">=</span> <span class="ident">vr_div10</span>;
            <span class="ident">vp</span> <span class="op">=</span> <span class="ident">vp_div10</span>;
            <span class="ident">vm</span> <span class="op">=</span> <span class="ident">vm_div10</span>;
            <span class="ident">removed</span> <span class="op">+</span><span class="op">=</span> <span class="number">1</span>;
        }
        <span class="kw">if</span> <span class="ident">vm_is_trailing_zeros</span> {
            <span class="kw">loop</span> {
                <span class="kw">let</span> <span class="ident">vm_div10</span> <span class="op">=</span> <span class="ident">div10</span>(<span class="ident">vm</span>);
                <span class="kw">let</span> <span class="ident">vm_mod10</span> <span class="op">=</span> (<span class="ident">vm</span> <span class="kw">as</span> <span class="ident">u32</span>).<span class="ident">wrapping_sub</span>(<span class="number">10u32</span>.<span class="ident">wrapping_mul</span>(<span class="ident">vm_div10</span> <span class="kw">as</span> <span class="ident">u32</span>));
                <span class="kw">if</span> <span class="ident">vm_mod10</span> <span class="op">!</span><span class="op">=</span> <span class="number">0</span> {
                    <span class="kw">break</span>;
                }
                <span class="kw">let</span> <span class="ident">vp_div10</span> <span class="op">=</span> <span class="ident">div10</span>(<span class="ident">vp</span>);
                <span class="kw">let</span> <span class="ident">vr_div10</span> <span class="op">=</span> <span class="ident">div10</span>(<span class="ident">vr</span>);
                <span class="kw">let</span> <span class="ident">vr_mod10</span> <span class="op">=</span> (<span class="ident">vr</span> <span class="kw">as</span> <span class="ident">u32</span>).<span class="ident">wrapping_sub</span>(<span class="number">10u32</span>.<span class="ident">wrapping_mul</span>(<span class="ident">vr_div10</span> <span class="kw">as</span> <span class="ident">u32</span>));
                <span class="ident">vr_is_trailing_zeros</span> <span class="op">&amp;=</span> <span class="ident">last_removed_digit</span> <span class="op">==</span> <span class="number">0</span>;
                <span class="ident">last_removed_digit</span> <span class="op">=</span> <span class="ident">vr_mod10</span> <span class="kw">as</span> <span class="ident">u8</span>;
                <span class="ident">vr</span> <span class="op">=</span> <span class="ident">vr_div10</span>;
                <span class="ident">vp</span> <span class="op">=</span> <span class="ident">vp_div10</span>;
                <span class="ident">vm</span> <span class="op">=</span> <span class="ident">vm_div10</span>;
                <span class="ident">removed</span> <span class="op">+</span><span class="op">=</span> <span class="number">1</span>;
            }
        }
        <span class="kw">if</span> <span class="ident">vr_is_trailing_zeros</span> <span class="op">&amp;&amp;</span> <span class="ident">last_removed_digit</span> <span class="op">==</span> <span class="number">5</span> <span class="op">&amp;&amp;</span> <span class="ident">vr</span> <span class="op">%</span> <span class="number">2</span> <span class="op">==</span> <span class="number">0</span> {
            <span class="comment">// Round even if the exact number is .....50..0.</span>
            <span class="ident">last_removed_digit</span> <span class="op">=</span> <span class="number">4</span>;
        }
        <span class="comment">// We need to take vr + 1 if vr is outside bounds or we need to round up.</span>
        <span class="ident">vr</span> <span class="op">+</span> ((<span class="ident">vr</span> <span class="op">==</span> <span class="ident">vm</span> <span class="op">&amp;&amp;</span> (<span class="op">!</span><span class="ident">accept_bounds</span> <span class="op">|</span><span class="op">|</span> <span class="op">!</span><span class="ident">vm_is_trailing_zeros</span>)) <span class="op">|</span><span class="op">|</span> <span class="ident">last_removed_digit</span> <span class="op">&gt;</span><span class="op">=</span> <span class="number">5</span>)
            <span class="kw">as</span> <span class="ident">u64</span>
    } <span class="kw">else</span> {
        <span class="comment">// Specialized for the common case (~99.3%). Percentages below are relative to this.</span>
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">round_up</span> <span class="op">=</span> <span class="bool-val">false</span>;
        <span class="kw">let</span> <span class="ident">vp_div100</span> <span class="op">=</span> <span class="ident">div100</span>(<span class="ident">vp</span>);
        <span class="kw">let</span> <span class="ident">vm_div100</span> <span class="op">=</span> <span class="ident">div100</span>(<span class="ident">vm</span>);
        <span class="comment">// Optimization: remove two digits at a time (~86.2%).</span>
        <span class="kw">if</span> <span class="ident">vp_div100</span> <span class="op">&gt;</span> <span class="ident">vm_div100</span> {
            <span class="kw">let</span> <span class="ident">vr_div100</span> <span class="op">=</span> <span class="ident">div100</span>(<span class="ident">vr</span>);
            <span class="kw">let</span> <span class="ident">vr_mod100</span> <span class="op">=</span> (<span class="ident">vr</span> <span class="kw">as</span> <span class="ident">u32</span>).<span class="ident">wrapping_sub</span>(<span class="number">100u32</span>.<span class="ident">wrapping_mul</span>(<span class="ident">vr_div100</span> <span class="kw">as</span> <span class="ident">u32</span>));
            <span class="ident">round_up</span> <span class="op">=</span> <span class="ident">vr_mod100</span> <span class="op">&gt;</span><span class="op">=</span> <span class="number">50</span>;
            <span class="ident">vr</span> <span class="op">=</span> <span class="ident">vr_div100</span>;
            <span class="ident">vp</span> <span class="op">=</span> <span class="ident">vp_div100</span>;
            <span class="ident">vm</span> <span class="op">=</span> <span class="ident">vm_div100</span>;
            <span class="ident">removed</span> <span class="op">+</span><span class="op">=</span> <span class="number">2</span>;
        }
        <span class="comment">// Loop iterations below (approximately), without optimization above:</span>
        <span class="comment">// 0: 0.03%, 1: 13.8%, 2: 70.6%, 3: 14.0%, 4: 1.40%, 5: 0.14%, 6+: 0.02%</span>
        <span class="comment">// Loop iterations below (approximately), with optimization above:</span>
        <span class="comment">// 0: 70.6%, 1: 27.8%, 2: 1.40%, 3: 0.14%, 4+: 0.02%</span>
        <span class="kw">loop</span> {
            <span class="kw">let</span> <span class="ident">vp_div10</span> <span class="op">=</span> <span class="ident">div10</span>(<span class="ident">vp</span>);
            <span class="kw">let</span> <span class="ident">vm_div10</span> <span class="op">=</span> <span class="ident">div10</span>(<span class="ident">vm</span>);
            <span class="kw">if</span> <span class="ident">vp_div10</span> <span class="op">&lt;</span><span class="op">=</span> <span class="ident">vm_div10</span> {
                <span class="kw">break</span>;
            }
            <span class="kw">let</span> <span class="ident">vr_div10</span> <span class="op">=</span> <span class="ident">div10</span>(<span class="ident">vr</span>);
            <span class="kw">let</span> <span class="ident">vr_mod10</span> <span class="op">=</span> (<span class="ident">vr</span> <span class="kw">as</span> <span class="ident">u32</span>).<span class="ident">wrapping_sub</span>(<span class="number">10u32</span>.<span class="ident">wrapping_mul</span>(<span class="ident">vr_div10</span> <span class="kw">as</span> <span class="ident">u32</span>));
            <span class="ident">round_up</span> <span class="op">=</span> <span class="ident">vr_mod10</span> <span class="op">&gt;</span><span class="op">=</span> <span class="number">5</span>;
            <span class="ident">vr</span> <span class="op">=</span> <span class="ident">vr_div10</span>;
            <span class="ident">vp</span> <span class="op">=</span> <span class="ident">vp_div10</span>;
            <span class="ident">vm</span> <span class="op">=</span> <span class="ident">vm_div10</span>;
            <span class="ident">removed</span> <span class="op">+</span><span class="op">=</span> <span class="number">1</span>;
        }
        <span class="comment">// We need to take vr + 1 if vr is outside bounds or we need to round up.</span>
        <span class="ident">vr</span> <span class="op">+</span> (<span class="ident">vr</span> <span class="op">==</span> <span class="ident">vm</span> <span class="op">|</span><span class="op">|</span> <span class="ident">round_up</span>) <span class="kw">as</span> <span class="ident">u64</span>
    };
    <span class="kw">let</span> <span class="ident">exp</span> <span class="op">=</span> <span class="ident">e10</span> <span class="op">+</span> <span class="ident">removed</span>;

    <span class="ident">FloatingDecimal64</span> {
        <span class="ident">exponent</span>: <span class="ident">exp</span>,
        <span class="ident">mantissa</span>: <span class="ident">output</span>,
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="ryu" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>